<?php

namespace Modules\User\Requests\Store;

use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\Rule;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;
use Modules\Store\Enums\StatusShowSoldEnum;
use Modules\User\Enums\UserRoleEnum;

class ProfileRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules =
            [
                'email'=>
                    [
                        'required',
                        'email',
                        Rule::unique('stores','email')->ignore(auth()->user()->store_id),
                        Rule::unique('users','email')->ignore(auth()->user()->id)
                    ],
                'phone'=>
                    [
                        'required',
                        'numeric',
                        Rule::unique('stores','phone')->ignore(auth()->user()->store_id),
                        Rule::unique('users','phone')->ignore(auth()->user()->id)
                    ],
                'brand_ids'=>
                    [
                        'required',
                        'array'
                    ],
                'brand_ids.*'=>
                    [
                        'required',
                        Rule::exists('brands','id')->whereNull('deleted_at')
                    ],
                'password'=>
                    [
                      'sometimes',
                        'confirmed'
                    ],
            ];

        foreach (languages() as $lang)
        {
            $lang_rules=[
                'title_'.$lang->local=> 'required|max:150',
            ];
            $rules= array_merge($rules, $lang_rules);
        }


        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {

        $attributes= [
            'email'=>__('stores.email'),
            'password'=>__('stores.password'),
            'phone'=>__('stores.phone'),
            'brand_ids'=>__('stores.brand_id'),
            'twitter'=>__('stores.twitter'),
            'instagram'=>__('stores.instagram'),
            'bank_account'=>__('stores.bank_account'),
            'tax_percentage'=>__('stores.tax_percentage'),
            'status_show_sold'=>__('stores.status_show_sold'),
            'logo'=>__('stores.logo'),
        ];
        foreach (languages() as $lang) {
            $lang_attributes=[
                'title_'.$lang->local => __('stores.title').' '.$lang->local,
                'description_'.$lang->local => __('stores.description').' '.$lang->local,
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }
        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
